<template>
    <div class="container">
        <ul>
            <li class="icon"
                :class="{disabled: imagePosition === 0}"
                v-tooltip.right="{
                  content: 'Add a tag',
                  classes: ['info'],
                  delay: {
                    show: 600,
                    hide: 300,
                  },
                }"
                @click="addCircle"><font-awesome-icon :icon="['far', 'plus-square']" size="lg"/></li>
            <li class="icon"
                v-tooltip.right="{
                  content: 'Delete selected tag',
                  classes: ['info'],
                  delay: {
                    show: 600,
                    hide: 300,
                  },
                }"
                @click="deleteCurrentTag"><font-awesome-icon icon="trash-alt" size="lg"/></li>
            <li v-if="!isUploading"
                class="upload"
                :class="{disabled: imagePosition === 0}"
                v-tooltip.right="{
                  content: 'Upload tags',
                  classes: ['info'],
                  delay: {
                    show: 600,
                    hide: 300,
                  },
                }" @click="exportTags">
                <app-badge
                        :color="'goldenrod'"
                        :counter="numberOfChanges">
                    <font-awesome-icon class="icon" icon="cloud-upload-alt" size="lg"/>
                </app-badge>

            </li>
            <li v-if="isUploading"
                class="icon">
                <beat-loader
                        :loading="isUploading"
                        :color="color"
                        :size="size"></beat-loader></li>
            <li v-if="!isSynchronizing"
                class="icon sync"
                v-tooltip.right="{
                  content: 'Retrieve tags',
                  classes: ['info'],
                  delay: {
                    show: 600,
                    hide: 300,
                  },
                }" @click="retrieveData"><font-awesome-icon icon="sync-alt" size="lg"/></li>
            <li v-if="isSynchronizing"
                class="icon">
                <beat-loader
                        :loading="isSynchronizing"
                        :color="color"
                        :size="size"></beat-loader></li>
        </ul>
    </div>
</template>

<script>
    import BeatLoader from 'vue-spinner/src/BeatLoader.vue'
    import Badge from './Badge.vue';

    export default {
        name: 'DrawControls',
        props: {
          addCircle: {
            type: Function
          },
          exportTags: {
            type: Function
          },
          retrieveData: {
            type: Function
          },
          deleteCurrentTag: {
            type: Function
          },
          isUploading: {
            type: Boolean
          },
          isSynchronizing: {
            type: Boolean
          },
          imagePosition: {
            type: Number
          },
          numberOfChanges: {
            type: Number
          }
        },
        components: {
          BeatLoader: BeatLoader,
          appBadge: Badge
        },
        data: () => {
          return {
            color: 'goldenrod',
            size: '15px',
          }
        },
    }
</script>

<style scoped>
    .container {
        width: 90px;
    }
    ul {
        list-style-type: none;
        margin: 0;
        padding: 10px;
        /*background-color: white;*/
        border-radius: 10px;
        display: flex;
        flex-flow: column;
        justify-content: space-around;
        height: 100%;
    }
    li {
        cursor: pointer;
    }
    input {
        width: 40px;
    }
    .icon:hover {
        color: goldenrod;
    }
    .icon.active {
        color: goldenrod;
    }
    .disabled {
        cursor: not-allowed;
        pointer-events: none;
        opacity:0.6;
    }
    .upload, .sync {
        transition: opacity .5s ease-out;
    }
</style>